## e1000e-dkms 1.1.2-ig1

=== src/Makefile ===
################################################################################
#
# Intel PRO/1000 Linux driver
# Copyright(c) 1999 - 2009 Intel Corporation.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
#
# The full GNU General Public License is included in this distribution in
# the file called "COPYING".
#
# Contact Information:
# Linux NICS <linux.nics@intel.com>
# e1000-devel Mailing List <e1000-devel@lists.sourceforge.net>
# Intel Corporation, 5200 N.E. Elam Young Parkway, Hillsboro, OR 97124-6497
#
################################################################################

###########################################################################
# Driver files
FAMILYC = e1000_82571.c e1000_ich8lan.c e1000_80003es2lan.c
FAMILYH = e1000_82571.h e1000_ich8lan.h e1000_80003es2lan.h

# core driver files
CFILES = netdev.c ethtool.c param.c $(FAMILYC) \
         e1000_mac.c e1000_nvm.c e1000_phy.c e1000_manage.c kcompat.c
HFILES = e1000.h hw.h e1000_regs.h e1000_defines.h \
         e1000_mac.h e1000_nvm.h e1000_phy.h e1000_manage.h $(FAMILYH) kcompat.h
ifeq (,$(BUILD_KERNEL))
BUILD_KERNEL=$(shell uname -r)
endif

DRIVER_NAME = e1000e

###########################################################################
# Environment tests

# Kernel Search Path
# All the places we look for kernel source
KSP :=  /lib/modules/$(BUILD_KERNEL)/build \
        /lib/modules/$(BUILD_KERNEL)/source \
        /usr/src/linux-$(BUILD_KERNEL) \
        /usr/src/linux-$($(BUILD_KERNEL) | sed 's/-.*//') \
        /usr/src/kernel-headers-$(BUILD_KERNEL) \
        /usr/src/kernel-source-$(BUILD_KERNEL) \
        /usr/src/linux-$($(BUILD_KERNEL) | sed 's/\([0-9]*\.[0-9]*\)\..*/\1/') \
        /usr/src/linux

# prune the list down to only values that exist
# and have an include/linux sub-directory
test_dir = $(shell [ -e $(dir)/include/linux ] && echo $(dir))
KSP := $(foreach dir, $(KSP), $(test_dir))

# we will use this first valid entry in the search path
ifeq (,$(KSRC))
  KSRC := $(firstword $(KSP))
endif

ifeq (,$(KSRC))
  $(warning *** Linux kernel source not found in any of these locations:)
  $(warning $(KSP))
  $(warning *** Install the appropriate kernel development package, e.g.)
  $(error kernel-devel, for building kernel modules and try again)
else
ifeq (/lib/modules/$(shell uname -r)/source, $(KSRC))
  KOBJ :=  /lib/modules/$(shell uname -r)/build
else
  KOBJ :=  $(KSRC)
endif
endif

# check for version.h and autoconf.h for running kernel in /boot (SUSE)
ifneq (,$(wildcard /boot/vmlinuz.version.h))
  VERSION_FILE := /boot/vmlinuz.version.h
  CONFIG_FILE  := /boot/vmlinuz.autoconf.h
  KVER := $(shell $(CC) $(EXTRA_CFLAGS) -E -dM $(VERSION_FILE) | \
          grep UTS_RELEASE | awk '{ print $$3 }' | sed 's/\"//g')
  ifeq ($(KVER),$(shell uname -r))
    # set up include path to override headers from kernel source
    x:=$(shell rm -rf include)
    x:=$(shell mkdir -p include/linux)
    x:=$(shell cp /boot/vmlinuz.version.h include/linux/version.h)
    x:=$(shell cp /boot/vmlinuz.autoconf.h include/linux/autoconf.h)
    EXTRA_CFLAGS += -I./include
  else
    ifneq (,$(wildcard $(KOBJ)/include/linux/utsrelease.h))
      VERSION_FILE := $(KOBJ)/include/linux/utsrelease.h
    else
      VERSION_FILE := $(KOBJ)/include/linux/version.h
    endif
    CONFIG_FILE  := $(KSRC)/include/linux/autoconf.h
  endif
else
  ifneq (,$(wildcard $(KOBJ)/include/linux/utsrelease.h))
    VERSION_FILE := $(KOBJ)/include/linux/utsrelease.h
  else
    VERSION_FILE := $(KOBJ)/include/linux/version.h
  endif
  CONFIG_FILE  := $(KSRC)/include/linux/autoconf.h
endif

ifeq (,$(wildcard $(VERSION_FILE)))
  $(error Linux kernel source not configured - missing version.h)
endif

ifeq (,$(wildcard $(CONFIG_FILE)))
  $(error Linux kernel source not configured - missing autoconf.h)
endif

# pick a compiler
ifneq (,$(findstring egcs-2.91.66, $(shell cat /proc/version)))
  CC := kgcc gcc cc
else
  CC := gcc cc
endif
test_cc = $(shell $(cc) --version > /dev/null 2>&1 && echo $(cc))
CC := $(foreach cc, $(CC), $(test_cc))
CC := $(firstword $(CC))
ifeq (,$(CC))
  $(error Compiler not found)
endif

# we need to know what platform the driver is being built on
# some additional features are only built on Intel platforms
ARCH := $(shell uname -m | sed 's/i.86/i386/')
ifeq ($(ARCH),alpha)
  EXTRA_CFLAGS += -ffixed-8 -mno-fp-regs
endif
ifeq ($(ARCH),x86_64)
  EXTRA_CFLAGS += -mcmodel=kernel -mno-red-zone
endif
ifeq ($(ARCH),ppc)
  EXTRA_CFLAGS += -msoft-float
endif
ifeq ($(ARCH),ppc64)
  EXTRA_CFLAGS += -m64 -msoft-float
  LDFLAGS += -melf64ppc
endif
ifneq (,$(findstring NO_82542_SUPPORT, $(CFLAGS_EXTRA)))
  CFILES := $(filter-out e1000_82542.c, $(CFILES))
endif

# extra flags for module builds
EXTRA_CFLAGS += -DDRIVER_$(shell echo $(DRIVER_NAME) | tr '[a-z]' '[A-Z]')
EXTRA_CFLAGS += -DDRIVER_NAME=$(DRIVER_NAME)
EXTRA_CFLAGS += -DDRIVER_NAME_CAPS=$(shell echo $(DRIVER_NAME) | tr '[a-z]' '[A-Z]')
# standard flags for module builds
EXTRA_CFLAGS += -DLINUX -D__KERNEL__ -DMODULE -O2 -pipe -Wall
EXTRA_CFLAGS += -I$(KSRC)/include -I.
EXTRA_CFLAGS += $(shell [ -f $(KSRC)/include/linux/modversions.h ] && \
            echo "-DMODVERSIONS -DEXPORT_SYMTAB \
                  -include $(KSRC)/include/linux/modversions.h")

EXTRA_CFLAGS += $(CFLAGS_EXTRA)

RHC := $(KSRC)/include/linux/rhconfig.h
ifneq (,$(wildcard $(RHC)))
  # 7.3 typo in rhconfig.h
  ifneq (,$(shell $(CC) $(EXTRA_CFLAGS) -E -dM $(RHC) | grep __module__bigmem))
	EXTRA_CFLAGS += -D__module_bigmem
  endif
endif

# get the kernel version - we use this to find the correct install path
KVER := $(shell $(CC) $(EXTRA_CFLAGS) -E -dM $(VERSION_FILE) | grep UTS_RELEASE | \
        awk '{ print $$3 }' | sed 's/\"//g')

# assume source symlink is the same as build, otherwise adjust KOBJ
ifneq (,$(wildcard /lib/modules/$(KVER)/build))
ifneq ($(KSRC),$(shell cd /lib/modules/$(KVER)/build ; pwd -P))
  KOBJ=/lib/modules/$(KVER)/build
endif
endif

KKVER := $(shell echo $(KVER) | \
         awk '{ if ($$0 ~ /2\.[4-9]\./) print "1"; else print "0"}')
ifeq ($(KKVER), 0)
  $(error *** Aborting the build. \
          *** This driver is not supported on kernel versions older than 2.4.0)
endif

# set the install path
INSTDIR := /lib/modules/$(KVER)/kernel/drivers/net/$(DRIVER_NAME)

# look for SMP in config.h
SMP := $(shell $(CC) $(EXTRA_CFLAGS) -E -dM $(CONFIG_FILE) | \
         grep -w CONFIG_SMP | awk '{ print $$3 }')
ifneq ($(SMP),1)
  SMP := 0
endif

ifneq ($(SMP),$(shell uname -a | grep SMP > /dev/null 2>&1 && echo 1 || echo 0))
  $(warning ***)
  ifeq ($(SMP),1)
    $(warning *** Warning: kernel source configuration (SMP))
    $(warning *** does not match running kernel (UP))
  else
    $(warning *** Warning: kernel source configuration (UP))
    $(warning *** does not match running kernel (SMP))
  endif
  $(warning *** Continuing with build,)
  $(warning *** resulting driver may not be what you want)
  $(warning ***)
endif

ifeq ($(SMP),1)
  EXTRA_CFLAGS += -D__SMP__
endif

###########################################################################
# 2.4.x & 2.6.x Specific rules

K_VERSION:=$(shell uname -r | cut -c1-3 | sed 's/2\.[56]/2\.6/')

ifeq ($(K_VERSION), 2.6)

# Makefile for 2.6.x kernel
TARGET = $(DRIVER_NAME).ko

# man page
MANSECTION = 7
MANFILE = $(TARGET:.ko=.$(MANSECTION))

ifneq ($(PATCHLEVEL),)
EXTRA_CFLAGS += $(CFLAGS_EXTRA)
obj-m += $(DRIVER_NAME).o
$(DRIVER_NAME)-objs := $(CFILES:.c=.o)
else
default:
ifeq ($(KOBJ),$(KSRC))
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd) modules
else
	$(MAKE) -C $(KSRC) O=$(KOBJ) SUBDIRS=$(shell pwd) modules
endif
endif

else # ifeq ($(K_VERSION),2.6)

# Makefile for 2.4.x kernel
TARGET = $(DRIVER_NAME).o

# man page
MANSECTION = 7
MANFILE = $(TARGET:.o=.$(MANSECTION))

# Get rid of compile warnings in kernel header files from SuSE
ifneq (,$(wildcard /etc/SuSE-release))
  EXTRA_CFLAGS += -Wno-sign-compare -fno-strict-aliasing
endif

# Get rid of compile warnings in kernel header files from fedora
ifneq (,$(wildcard /etc/fedora-release))
  EXTRA_CFLAGS += -fno-strict-aliasing
endif
CFLAGS += $(EXTRA_CFLAGS)

.SILENT: $(TARGET)
$(TARGET): $(filter-out $(TARGET), $(CFILES:.c=.o))
	$(LD) $(LDFLAGS) -r $^ -o $@
	echo; echo
	echo "**************************************************"
	echo "** $(TARGET) built for $(KVER)"
	echo -n "** SMP               "
	if [ "$(SMP)" = "1" ]; \
		then echo "Enabled"; else echo "Disabled"; fi
	echo "**************************************************"
	echo

$(CFILES:.c=.o): $(HFILES) Makefile
default:
	$(MAKE)

endif # ifeq ($(K_VERSION),2.6)

ifeq (,$(MANDIR))
  # find the best place to install the man page
  MANPATH := $(shell (manpath 2>/dev/null || echo $MANPATH) | sed 's/:/ /g')
  ifneq (,$(MANPATH))
    # test based on inclusion in MANPATH
    test_dir = $(findstring $(dir), $(MANPATH))
  else
    # no MANPATH, test based on directory existence
    test_dir = $(shell [ -e $(dir) ] && echo $(dir))
  endif
  # our preferred install path
  # should /usr/local/man be in here ?
  MANDIR := /usr/share/man /usr/man
  MANDIR := $(foreach dir, $(MANDIR), $(test_dir))
  MANDIR := $(firstword $(MANDIR))
endif
ifeq (,$(MANDIR))
  # fallback to /usr/man
  MANDIR := /usr/man
endif

# depmod version for rpm builds
DEPVER := $(shell /sbin/depmod -V 2>/dev/null | \
          awk 'BEGIN {FS="."} NR==1 {print $$2}')

###########################################################################
# Build rules

$(MANFILE).gz: ../$(MANFILE)
	gzip -c $< > $@

install: default $(MANFILE).gz
	# remove all old versions of the driver
	find $(INSTALL_MOD_PATH)/lib/modules/$(KVER) -name $(TARGET) -exec rm -f {} \; || true
	find $(INSTALL_MOD_PATH)/lib/modules/$(KVER) -name $(TARGET).gz -exec rm -f {} \; || true
	install -D -m 644 $(TARGET) $(INSTALL_MOD_PATH)$(INSTDIR)/$(TARGET)
ifeq (,$(INSTALL_MOD_PATH))
	/sbin/depmod -a || true
else
  ifeq ($(DEPVER),1 )
	/sbin/depmod -r $(INSTALL_MOD_PATH) -a || true
  else
	/sbin/depmod -b $(INSTALL_MOD_PATH) -a -n $(KVERSION) > /dev/null || true
  endif
endif
	install -D -m 644 $(MANFILE).gz $(INSTALL_MOD_PATH)$(MANDIR)/man$(MANSECTION)/$(MANFILE).gz
	man -c -P'cat > /dev/null' $(MANFILE:.$(MANSECTION)=) || true

uninstall:
	if [ -e $(INSTDIR)/$(TARGET) ] ; then \
	    rm -f $(INSTDIR)/$(TARGET) ; \
	fi
	/sbin/depmod -a
	if [ -e $(MANDIR)/man$(MANSECTION)/$(MANFILE).gz ] ; then \
		rm -f $(MANDIR)/man$(MANSECTION)/$(MANFILE).gz ; \
	fi

.PHONY: clean install

clean:
ifeq ($(KOBJ),$(KSRC))
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd) clean
else
	$(MAKE) -C $(KSRC) O=$(KOBJ) SUBDIRS=$(shell pwd) clean
endif
	rm -rf $(TARGET) $(TARGET:.ko=.o) $(TARGET:.ko=.mod.c) $(TARGET:.ko=.mod.o) $(CFILES:.c=.o) $(MANFILE).gz .*cmd .tmp_versions Module.markers Module.symvers modules.order

=== debian/changelog ===
e1000e-dkms (1.1.2-ig1) hardy; urgency=low

  * initial release

 -- Guido S. Nickels <g.nickels@plusserver.de>  Thu, 11 Feb 2010 10:05:08 +0100

=== debian/control ===
Source: e1000e-dkms
Section: admin
Priority: optional
Maintainer: Guido S. Nickels <g.nickels@plusserver.de>
Build-Depends: debhelper (>> 4.0.0), gzip, tar, sed, grep
Standards-Version: 3.8.0

Package: e1000e-dkms
Architecture: all
Depends: make, dkms, linux-libc-dev, libc6-dev, gcc, linux-headers-generic | linux-headers-server | linux-headers
Description: Intel e1000e ethernet driver source
 This is the original e1000e driver from sourceforge, with support
 for Intel 82578DM and some other newer chipsets not supported by the
 driver included in the Debian/Ubuntu kernel.

=== debian/rules ===
#!/usr/bin/make -f

build:
	tar --transform='s,/*[^/]*,source,' -xzf source.tar.gz
	sed -i "s/###VERSION###/$$(grep -o -m 1 '\([0-9]\.\)\+[0-9]\+' debian/changelog)/g" debian/install
	dh_testdir

clean:
	dh_testdir
	dh_testroot
	dh_clean
	sed -i "s/e1000e-[^-]*$$/e1000e-###VERSION###/g" debian/install
	rm -rf source

install:
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

binary-arch:

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs source/README
	dh_install
	dh_installman source/e1000e.7
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## e1000e-dkms 3.2.7.1

=== Makefile ===
#/usr/bin/make
SRC = $(DESTDIR)/usr/src
SHARE = $(DESTDIR)/usr/share/$(NAME)-dkms

all:

clean:

install:

#source tree
ifeq ("$(wildcard $(NAME))", "$(NAME)")
	cp -a "$(NAME)" "$(SRC)/$(NAME)-$(VERSION)"
	chmod 644 -R "$(SRC)/$(NAME)-$(VERSION)"
endif

#tarball, possibly with binaries
ifeq ("$(wildcard $(NAME)-$(VERSION).dkms.tar.gz)", "$(NAME)-$(VERSION).dkms.tar.gz")
	install -d "$(SHARE)"
	install -m 644 $(NAME)-$(VERSION).dkms.tar.gz "$(SHARE)"
endif

#postinst, only if we are supporting legacy mode
ifeq ("$(wildcard common.postinst)", "common.postinst")
	install -d "$(SHARE)"
	install -m 755 $(PREFIX)/usr/lib/dkms/common.postinst $(SHARE)/postinst
endif

#force, force install modules
ifeq ("$(wildcard $(NAME).force)", "$(NAME).force")
	install -d $(DESTDIR)/usr/share/dkms/modules_to_force_install
	install -m 644 $(NAME).force $(DESTDIR)/usr/share/dkms/modules_to_force_install
endif

=== debian/changelog ===
e1000e-dkms (3.2.7.1) trusty; urgency=medium

  * Fix I219-LM unit hang issue when plugging in/out the ethernet cord
    really fast. (LP: #1496724)

 -- Kai-Heng Feng <kai.heng.feng@canonical.com>  Tue, 06 Oct 2015 17:54:17 +0800

e1000e-dkms (1.0) trusty; urgency=medium

  * Automatically packaged by DKMS.
  * Fix S3 hang caused by e1000e. (LP: #1481655)

 -- Kai-Heng Feng <kai.heng.feng@canonical.com>  Thu, 13 Aug 2015 18:15:18 +0800

=== debian/control ===
Source: e1000e-dkms
Section: misc
Priority: optional
Maintainer: Commercial Engineering <commercial-engineering@canonical.com>
Build-Depends: debhelper (>= 7), dkms, dh-modaliases
Standards-Version: 3.8.1

Package: e1000e-dkms
Architecture: all
Depends: dkms (>= 1.95), ${misc:Depends}
Description: e1000e driver in DKMS format.
XB-Modaliases: ${modaliases}

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_NAME=e1000e
NAME=e1000e
VERSION=3.2.7.1

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	-$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/$(DEB_NAME)-dkms NAME=$(NAME) VERSION=$(VERSION) install

binary-arch: build install

binary-indep: build install
	dh_modaliases
	dh_testdir
	dh_testroot
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## e1000e-dkms 3.4.2.4

=== src/Makefile ===
--- 
+++ 
@@ -1,41 +1,16 @@
-################################################################################
-#
-# Intel PRO/1000 Linux driver
-# Copyright(c) 1999 - 2009 Intel Corporation.
-#
-# This program is free software; you can redistribute it and/or modify it
-# under the terms and conditions of the GNU General Public License,
-# version 2, as published by the Free Software Foundation.
-#
-# This program is distributed in the hope it will be useful, but WITHOUT
-# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-# more details.
-#
-# You should have received a copy of the GNU General Public License along with
-# this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
-#
-# The full GNU General Public License is included in this distribution in
-# the file called "COPYING".
-#
-# Contact Information:
-# Linux NICS <linux.nics@intel.com>
-# e1000-devel Mailing List <e1000-devel@lists.sourceforge.net>
-# Intel Corporation, 5200 N.E. Elam Young Parkway, Hillsboro, OR 97124-6497
-#
-################################################################################
+# SPDX-License-Identifier: GPL-2.0
+# Copyright(c) 1999 - 2019 Intel Corporation.
 
 ###########################################################################
 # Driver files
-FAMILYC = e1000_82571.c e1000_ich8lan.c e1000_80003es2lan.c
-FAMILYH = e1000_82571.h e1000_ich8lan.h e1000_80003es2lan.h
+FAMILYC = 82571.c ich8lan.c 80003es2lan.c
+FAMILYH = 82571.h ich8lan.h 80003es2lan.h
 
 # core driver files
 CFILES = netdev.c ethtool.c param.c $(FAMILYC) \
-         e1000_mac.c e1000_nvm.c e1000_phy.c e1000_manage.c kcompat.c
-HFILES = e1000.h hw.h e1000_regs.h e1000_defines.h \
-         e1000_mac.h e1000_nvm.h e1000_phy.h e1000_manage.h $(FAMILYH) kcompat.h
+         mac.c nvm.c phy.c manage.c kcompat.c
+HFILES = e1000.h hw.h regs.h defines.h \
+         mac.h nvm.h phy.h manage.h $(FAMILYH) kcompat.h
 ifeq (,$(BUILD_KERNEL))
 BUILD_KERNEL=$(shell uname -r)
 endif
@@ -49,6 +24,7 @@
 # All the places we look for kernel source
 KSP :=  /lib/modules/$(BUILD_KERNEL)/build \
         /lib/modules/$(BUILD_KERNEL)/source \
+        /lib/modules/$(BUILD_KERNEL)-default/build \
         /usr/src/linux-$(BUILD_KERNEL) \
         /usr/src/linux-$($(BUILD_KERNEL) | sed 's/-.*//') \
         /usr/src/kernel-headers-$(BUILD_KERNEL) \
@@ -67,50 +43,44 @@
 endif
 
 ifeq (,$(KSRC))
-  $(warning *** Linux kernel source not found in any of these locations:)
-  $(warning $(KSP))
+  $(warning *** Kernel header files not in any of the expected locations.)
   $(warning *** Install the appropriate kernel development package, e.g.)
   $(error kernel-devel, for building kernel modules and try again)
 else
-ifeq (/lib/modules/$(shell uname -r)/source, $(KSRC))
-  KOBJ :=  /lib/modules/$(shell uname -r)/build
+ifeq (/lib/modules/$(BUILD_KERNEL)/source, $(KSRC))
+  KOBJ :=  /lib/modules/$(BUILD_KERNEL)/build
 else
   KOBJ :=  $(KSRC)
 endif
 endif
 
-# check for version.h and autoconf.h for running kernel in /boot (SUSE)
-ifneq (,$(wildcard /boot/vmlinuz.version.h))
-  VERSION_FILE := /boot/vmlinuz.version.h
-  CONFIG_FILE  := /boot/vmlinuz.autoconf.h
-  KVER := $(shell $(CC) $(EXTRA_CFLAGS) -E -dM $(VERSION_FILE) | \
-          grep UTS_RELEASE | awk '{ print $$3 }' | sed 's/\"//g')
-  ifeq ($(KVER),$(shell uname -r))
-    # set up include path to override headers from kernel source
-    x:=$(shell rm -rf include)
-    x:=$(shell mkdir -p include/linux)
-    x:=$(shell cp /boot/vmlinuz.version.h include/linux/version.h)
-    x:=$(shell cp /boot/vmlinuz.autoconf.h include/linux/autoconf.h)
-    EXTRA_CFLAGS += -I./include
-  else
-    ifneq (,$(wildcard $(KOBJ)/include/linux/utsrelease.h))
-      VERSION_FILE := $(KOBJ)/include/linux/utsrelease.h
-    else
-      VERSION_FILE := $(KOBJ)/include/linux/version.h
-    endif
-    CONFIG_FILE  := $(KSRC)/include/linux/autoconf.h
-  endif
-else
-  ifneq (,$(wildcard $(KOBJ)/include/linux/utsrelease.h))
-    VERSION_FILE := $(KOBJ)/include/linux/utsrelease.h
-  else
-    VERSION_FILE := $(KOBJ)/include/linux/version.h
-  endif
-  CONFIG_FILE  := $(KSRC)/include/linux/autoconf.h
+# Version file Search Path
+VSP :=  $(KOBJ)/include/generated/utsrelease.h \
+        $(KOBJ)/include/linux/utsrelease.h \
+        $(KOBJ)/include/linux/version.h \
+        $(KOBJ)/include/generated/uapi/linux/version.h \
+        /boot/vmlinuz.version.h
+
+# Config file Search Path
+CSP :=  $(KOBJ)/include/generated/autoconf.h \
+        $(KOBJ)/include/linux/autoconf.h \
+        /boot/vmlinuz.autoconf.h
+
+# prune the lists down to only files that exist
+test_file = $(shell [ -f $(file) ] && echo $(file))
+VSP := $(foreach file, $(VSP), $(test_file))
+CSP := $(foreach file, $(CSP), $(test_file))
+
+# and use the first valid entry in the Search Paths
+ifeq (,$(VERSION_FILE))
+  VERSION_FILE := $(firstword $(VSP))
+endif
+ifeq (,$(CONFIG_FILE))
+  CONFIG_FILE := $(firstword $(CSP))
 endif
 
 ifeq (,$(wildcard $(VERSION_FILE)))
-  $(error Linux kernel source not configured - missing version.h)
+  $(error Linux kernel source not configured - missing version header file)
 endif
 
 ifeq (,$(wildcard $(CONFIG_FILE)))
@@ -146,16 +116,13 @@
   EXTRA_CFLAGS += -m64 -msoft-float
   LDFLAGS += -melf64ppc
 endif
-ifneq (,$(findstring NO_82542_SUPPORT, $(CFLAGS_EXTRA)))
-  CFILES := $(filter-out e1000_82542.c, $(CFILES))
-endif
 
 # extra flags for module builds
 EXTRA_CFLAGS += -DDRIVER_$(shell echo $(DRIVER_NAME) | tr '[a-z]' '[A-Z]')
 EXTRA_CFLAGS += -DDRIVER_NAME=$(DRIVER_NAME)
 EXTRA_CFLAGS += -DDRIVER_NAME_CAPS=$(shell echo $(DRIVER_NAME) | tr '[a-z]' '[A-Z]')
 # standard flags for module builds
-EXTRA_CFLAGS += -DLINUX -D__KERNEL__ -DMODULE -O2 -pipe -Wall
+EXTRA_CFLAGS += -DLINUX -D__KERNEL__ -DMODULE -O2 -pipe -Wall -fno-pie
 EXTRA_CFLAGS += -I$(KSRC)/include -I.
 EXTRA_CFLAGS += $(shell [ -f $(KSRC)/include/linux/modversions.h ] && \
             echo "-DMODVERSIONS -DEXPORT_SYMTAB \
@@ -182,15 +149,53 @@
 endif
 endif
 
-KKVER := $(shell echo $(KVER) | \
-         awk '{ if ($$0 ~ /2\.[4-9]\./) print "1"; else print "0"}')
-ifeq ($(KKVER), 0)
+KVER_CODE := $(shell $(CC) $(EXTRA_CFLAGS) -E -dM $(VSP) 2>/dev/null |\
+	grep -m 1 LINUX_VERSION_CODE | awk '{ print $$3 }' | sed 's/\"//g')
+
+RHEL_CODE := $(shell $(CC) $(EXTRA_CFLAGS) -E -dM $(VSP) 2>/dev/null |\
+	grep -m 1 RHEL_RELEASE_CODE | awk '{ print $$3 }')
+
+# Determine SLE_LOCALVERSION_CODE for SuSE SLE (needed by kcompat)
+# This assumes SuSE will continue setting CONFIG_LOCALVERSION to the string
+# appended to the stable kernel version on which their kernel is based with
+# additional versioning information (up to 3 numbers) and a kernel type,
+# e.g. CONFIG_LOCALVERSION=-1.2.3-default
+ifeq (1,$(shell ${CC} -E -dM ${CONFIG_FILE} 2> /dev/null |\
+          grep -m 1 CONFIG_SUSE_KERNEL | awk '{ print $$3 }'))
+  LOCALVERSION := $(shell ${CC} -E -dM ${CONFIG_FILE} 2> /dev/null |\
+                    grep -m 1 CONFIG_LOCALVERSION | awk '{ print $$3 }' |\
+                    cut -d'-' -f2)
+  LOCALVER_A := $(shell echo ${LOCALVERSION} | cut -d'.' -f1)
+  LOCALVER_B := $(shell echo ${LOCALVERSION} | cut -d'.' -f2)
+  LOCALVER_C := $(shell echo ${LOCALVERSION} | cut -d'.' -f3)
+  SLE_LOCALVERSION_CODE := $(shell expr ${LOCALVER_A} \* 65536 + \
+                                        0${LOCALVER_B} \* 256 + 0${LOCALVER_C})
+  EXTRA_CFLAGS += -DSLE_LOCALVERSION_CODE=${SLE_LOCALVERSION_CODE}
+endif
+
+# abort the build on kernels older than 2.4.0
+ifneq (1,$(shell [ $(KVER_CODE) -ge 132096 ] && echo 1 || echo 0))
   $(error *** Aborting the build. \
           *** This driver is not supported on kernel versions older than 2.4.0)
 endif
 
+# Use NO_PTP_SUPPORT compile flag to disable IEEE-1588 PTP(documented in README)
+ifneq ($(filter %NO_PTP_SUPPORT,$(CFLAGS_EXTRA)),-DNO_PTP_SUPPORT)
+# Do not attempt to enable PTP on kernels that do not support it
+ifeq (1,$(shell ([ $(KVER_CODE) -ge 196608 ] || [ $(RHEL_CODE) -ge 1540 ]) && echo 1 || echo 0))
+include $(KOBJ)/include/config/auto.conf
+ifdef CONFIG_PTP_1588_CLOCK
+CFILES += ptp.c
+endif # CONFIG_PTP_1588_CLOCK
+endif # kernel version >= 3.0
+endif # NO_PTP_SUPPORT
+
 # set the install path
-INSTDIR := /lib/modules/$(KVER)/kernel/drivers/net/$(DRIVER_NAME)
+ifeq (1,$(shell [ $(KVER_CODE) -lt 197120 ] && echo 1 || echo 0))
+INSTDIR := /lib/modules/$(KVER)/updates/drivers/net/$(DRIVER_NAME)
+else
+INSTDIR := /lib/modules/$(KVER)/updates/drivers/net/ethernet/intel/$(DRIVER_NAME)
+endif
 
 # look for SMP in config.h
 SMP := $(shell $(CC) $(EXTRA_CFLAGS) -E -dM $(CONFIG_FILE) | \
@@ -217,14 +222,20 @@
   EXTRA_CFLAGS += -D__SMP__
 endif
 
+# Don't set gcc-i-sys.sh until after our $(shell) invocations of ${CC}
+ifneq ($(wildcard ./gcc-i-sys.sh),)
+GCC_I_SYS := $(shell readlink -f ./gcc-i-sys.sh)
+$(shell chmod +x ${GCC_I_SYS})
+export REAL_CC := ${CC}
+export CC := ${GCC_I_SYS}
+endif
+
 ###########################################################################
-# 2.4.x & 2.6.x Specific rules
-
-K_VERSION:=$(shell uname -r | cut -c1-3 | sed 's/2\.[56]/2\.6/')
-
-ifeq ($(K_VERSION), 2.6)
-
-# Makefile for 2.6.x kernel
+# Kernel Version Specific rules
+
+ifeq (1,$(shell [ $(KVER_CODE) -ge 132352 ] && echo 1 || echo 0))
+
+# Makefile for 2.5.x and newer kernel
 TARGET = $(DRIVER_NAME).ko
 
 # man page
@@ -238,13 +249,13 @@
 else
 default:
 ifeq ($(KOBJ),$(KSRC))
-	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd) modules
-else
-	$(MAKE) -C $(KSRC) O=$(KOBJ) SUBDIRS=$(shell pwd) modules
-endif
-endif
-
-else # ifeq ($(K_VERSION),2.6)
+	$(MAKE) -C $(KSRC) CC=${CC} SUBDIRS=$(shell pwd) modules
+else
+	$(MAKE) -C $(KSRC) CC=${CC} O=$(KOBJ) SUBDIRS=$(shell pwd) modules
+endif
+endif
+
+else # ifeq (1,$(shell [ $(KVER_CODE) -ge 132352 ] && echo 1 || echo 0))
 
 # Makefile for 2.4.x kernel
 TARGET = $(DRIVER_NAME).o
@@ -278,9 +289,9 @@
 
 $(CFILES:.c=.o): $(HFILES) Makefile
 default:
-	$(MAKE)
-
-endif # ifeq ($(K_VERSION),2.6)
+	$(MAKE) CC=${CC}
+
+endif # ifeq (1,$(shell [ $(KVER_CODE) -ge 132352 ] && echo 1 || echo 0))
 
 ifeq (,$(MANDIR))
   # find the best place to install the man page
@@ -319,12 +330,12 @@
 	find $(INSTALL_MOD_PATH)/lib/modules/$(KVER) -name $(TARGET).gz -exec rm -f {} \; || true
 	install -D -m 644 $(TARGET) $(INSTALL_MOD_PATH)$(INSTDIR)/$(TARGET)
 ifeq (,$(INSTALL_MOD_PATH))
-	/sbin/depmod -a || true
+	/sbin/depmod -a $(KVER) || true
 else
   ifeq ($(DEPVER),1 )
-	/sbin/depmod -r $(INSTALL_MOD_PATH) -a || true
+	/sbin/depmod -r $(INSTALL_MOD_PATH) -a $(KVER) || true
   else
-	/sbin/depmod -b $(INSTALL_MOD_PATH) -a -n $(KVERSION) > /dev/null || true
+	/sbin/depmod -b $(INSTALL_MOD_PATH) -a -n $(KVER) > /dev/null || true
   endif
 endif
 	install -D -m 644 $(MANFILE).gz $(INSTALL_MOD_PATH)$(MANDIR)/man$(MANSECTION)/$(MANFILE).gz
@@ -341,6 +352,9 @@
 
 .PHONY: clean install
 
+ksrc:
+	@echo $(KSRC)
+
 clean:
 ifeq ($(KOBJ),$(KSRC))
 	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd) clean
@@ -348,3 +362,4 @@
 	$(MAKE) -C $(KSRC) O=$(KOBJ) SUBDIRS=$(shell pwd) clean
 endif
 	rm -rf $(TARGET) $(TARGET:.ko=.o) $(TARGET:.ko=.mod.c) $(TARGET:.ko=.mod.o) $(CFILES:.c=.o) $(MANFILE).gz .*cmd .tmp_versions Module.markers Module.symvers modules.order
+

=== debian/changelog ===
e1000e-dkms (3.4.2.4-1~somerville3) bionic; urgency=medium

  * No-change rebuild.

 -- Anthony Wong <anthony.wong@canonical.com>  Mon, 08 Jul 2019 07:12:16 +0000

e1000e-dkms (3.4.2.4-ubuntu2) bionic; urgency=medium

  * Add dh-modaliases support.

 -- You-Sheng Yang <vicamo@gmail.com>  Mon, 8 Jul 2019 14:10:17 +0800

e1000e-dkms (3.4.2.4-ubuntu1) bionic; urgency=medium

  * Enable initrd rebuild.

 -- You-Sheng Yang <vicamo@gmail.com>  Thu, 4 Jul 2019 19:01:19 +0800

e1000e-dkms (3.4.2.4-1~somerville2) bionic; urgency=medium

  * Add REMAKE_INITRD="yes"

 -- Anthony Wong <anthony.wong@canonical.com>  Thu, 04 Jul 2019 11:02:22 +0000

e1000e-dkms (3.4.2.4-1~somerville1) bionic; urgency=medium

  * New upstream release 3.4.2.4.

 -- Anthony Wong <anthony.wong@canonical.com>  Tue, 2 Jul 2019 21:23:49 +0800

e1000e-dkms (3.4.2.3-1) UNRELEASED; urgency=medium

  * New upstream release 3.4.2.3.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:22:49 +0800

e1000e-dkms (3.4.2.1-1) UNRELEASED; urgency=medium

  * New upstream release 3.4.2.1.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:20:49 +0800

e1000e-dkms (3.4.1.1-1) UNRELEASED; urgency=medium

  * New upstream release 3.4.1.1.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:17:49 +0800

e1000e-dkms (3.4.0.2-1) UNRELEASED; urgency=medium

  * New upstream release 3.4.0.2.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:15:49 +0800

e1000e-dkms (3.3.6-1) UNRELEASED; urgency=medium

  * New upstream release 3.3.6.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:13:49 +0800

e1000e-dkms (3.3.5-1) UNRELEASED; urgency=medium

  * New upstream release 3.3.5.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:12:49 +0800

e1000e-dkms (3.3.4-1) UNRELEASED; urgency=medium

  * New upstream release 3.3.4.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:11:49 +0800

e1000e-dkms (3.3.3-1) UNRELEASED; urgency=medium

  * New upstream release 3.3.3.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:10:49 +0800

e1000e-dkms (3.3.1-1) UNRELEASED; urgency=medium

  * New upstream release 3.3.1.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 21:09:49 +0800

e1000e-dkms (3.2.7.1-1) UNRELEASED; urgency=medium

  * New upstream release 3.2.7.1.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 20:42:49 +0800

e1000e-dkms (3.2.4.2-1) UNRELEASED; urgency=medium

  * New upstream release 3.2.4.2.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 20:39:49 +0800

e1000e-dkms (3.1.0.2-1) UNRELEASED; urgency=medium

  * New upstream release 3.1.0.2.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 20:27:49 +0800

e1000e-dkms (3.1.0-1) UNRELEASED; urgency=medium

  * New upstream release 3.1.0.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 20:09:49 +0800

e1000e-dkms (3.0.4.1-1) UNRELEASED; urgency=medium

  * New upstream release 3.0.4.1.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 20:06:49 +0800

e1000e-dkms (3.0.4-1) UNRELEASED; urgency=medium

  * New upstream release 3.0.4.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 20:04:49 +0800

e1000e-dkms (2.5.4-1) UNRELEASED; urgency=medium

  * New upstream release 2.5.4.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 20:02:49 +0800

e1000e-dkms (2.4.14-1) UNRELEASED; urgency=medium

  * New upstream release 2.4.14.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 20:02:49 +0800

e1000e-dkms (2.2.14-1) UNRELEASED; urgency=medium

  * New upstream release 2.2.14.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:59:49 +0800

e1000e-dkms (2.1.4-1) UNRELEASED; urgency=medium

  * New upstream release 2.1.4.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:58:49 +0800

e1000e-dkms (2.0.0.1-1) UNRELEASED; urgency=medium

  * New upstream release 2.0.0.1.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:57:49 +0800

e1000e-dkms (2.0.0-1) UNRELEASED; urgency=medium

  * New upstream release 2.0.0.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:55:49 +0800

e1000e-dkms (1.11.3-1) UNRELEASED; urgency=medium

  * New upstream release 1.11.3.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:31:49 +0800

e1000e-dkms (1.10.6-1) UNRELEASED; urgency=medium

  * New upstream release 1.10.6.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:29:49 +0800

e1000e-dkms (1.9.5-1) UNRELEASED; urgency=medium

  * New upstream release 1.9.5.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:28:49 +0800

e1000e-dkms (1.6.3-1) UNRELEASED; urgency=medium

  * New upstream release 1.6.3.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:26:49 +0800

e1000e-dkms (1.6.2-1) UNRELEASED; urgency=medium

  * New upstream release 1.6.2.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:25:49 +0800

e1000e-dkms (1.5.1-1) UNRELEASED; urgency=medium

  * New upstream release 1.5.1.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:23:49 +0800

e1000e-dkms (1.4.4-1) UNRELEASED; urgency=medium

  * New upstream release 1.4.4.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:10:49 +0800

e1000e-dkms (1.3.17-1) UNRELEASED; urgency=medium

  * New upstream release 1.3.17.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:09:49 +0800

e1000e-dkms (1.3.10a-1) UNRELEASED; urgency=medium

  * New upstream release 1.3.10a.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:07:49 +0800

e1000e-dkms (1.2.20-1) UNRELEASED; urgency=medium

  * New upstream release 1.2.20.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 19:05:49 +0800

e1000e-dkms (1.2.17-1) UNRELEASED; urgency=medium

  * New upstream release 1.2.17.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 18:58:49 +0800

e1000e-dkms (1.2.10-1) UNRELEASED; urgency=medium

  * New upstream release 1.2.10.

 -- You-Sheng Yang <vicamo@gmail.com>  Tue, 2 Jul 2019 18:57:49 +0800



=== debian/control ===
Source: e1000e-dkms
Section: kernel
Priority: optional
Maintainer: You-Sheng Yang <vicamo@gmail.com>
Build-Depends:
 debhelper (>= 9~),
 dh-modaliases,
 dkms,
 quilt
Standards-Version: 4.1.4
Homepage: https://gitlab.com/vicamo/e1000e-dkms
Vcs-Browser: https://gitlab.com/vicamo/e1000e-dkms/tree/debian/master
Vcs-Git: https://gitlab.com/vicamo/e1000e-dkms.git

Package: e1000e-dkms
Architecture: all
Depends:
 dkms,
 ${misc:Depends},
Provides: e1000e-modules
XB-Modaliases: ${modaliases}
Description: e1000e Linux driver in DKMS format
 This package contains necessary files to build loadable kernel driver module
 with dkms.
 .
 Check /usr/share/doc/e1000e-dkms/README.gz for detailed information.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

DKMS_PACKAGE_NAME=$(patsubst %-dkms,%,$(DEB_SOURCE))
DKMS_PACKAGE_VERSION=$(DEB_VERSION_UPSTREAM)
GENERATED_DKMS_FILES= \
  debian/$(DEB_SOURCE).install \
  debian/$(DEB_SOURCE).dkms


%:
	dh $@ --with dkms,modaliases

override_dh_fixperms:
	dh_fixperms
	chmod 0644 debian/$(DEB_SOURCE)/usr/src/*/*

override_dh_install: debian/$(DEB_SOURCE).install
	dh_install --exclude=.gitignore

override_dh_dkms: debian/$(DEB_SOURCE).dkms
	dh_dkms -V $(DKMS_PACKAGE_VERSION)

$(GENERATED_DKMS_FILES) : $(GENERATED_DKMS_FILES:=.in) debian/rules
	sed -e 's,@DKMS_PACKAGE_NAME@,$(DKMS_PACKAGE_NAME),g' \
	    -e 's,@DKMS_PACKAGE_VERSION@,$(DKMS_PACKAGE_VERSION),g' \
	    <$(@:=.in) >$@

=== debian/tests/control ===
Tests: dkms-autopkgtest
Restrictions:
 needs-root,
 allow-stderr,
Depends:
 e1000e-dkms,
 linux-headers-686-pae | linux-headers-amd64 | linux-headers-generic | linux-headers,

Tests: check-modaliases
Depends:
 e1000e-dkms,
 kmod,
 linux-headers-686-pae | linux-headers-amd64 | linux-headers-generic | linux-headers,

Tests: check-initrd
Depends:
 e1000e-dkms,
 initramfs-tools-core,
 linux-headers-686-pae | linux-headers-amd64 | linux-headers-generic | linux-headers,
 linux-image-686-pae | linux-image-amd64 | linux-image-generic | linux-image,

=== debian/watch ===
version=4
http://sf.net/e1000/ e1000e-(.+)\.tar\.gz debian uupdate
